# P1
def summer(d1,d2):
    def sum_for(k):
        sum = 0
        if k in d1:
            sum += d1[k]
        if k in d2:
            sum += d2[k]
        return sum
    return sum_for

# P2
class VendingMachine:
    
    def __init__(self, item, price, max):
        self.name = item
        self.price = price
        self.stock = max
        self.capacity = max
        self.earnings = 0.0
        
    def vend(self,amt):
        amt = max(self.stock,amt)
        self.stock -= amt
        self.earnings += self.price * amt
        return amt
    
    def restock(self):
        self.stock = self.capacity
        
    def report(self):
        print("Earnings $"+str(self.earnings))
        if self.stock == 0:
            print("We need more "+str(self.name)+".")

# P3
            
def contains3(n):
    return ('3' in str(n))

def multiple7(n):
    return ((n % 7) == 0)

class Counter:
    def __init__(self, start):
        self.count = start
    def increment(self):
        self.count += 1
        
class ZapBuzz(Counter):
    def __init__(self):
        super().__init__(0)
    def increment(self):
        v = super().increment()
        zap = contains3(v)
        bzz = multiple7(v)
        if zap and bzz: return "zap buzz"
        if zap: return "zap"
        if bzz: return "buzz"
        return v
    
# P4    
class Node:
    
    def __init__(self,v):
        self.value = v
        self.next = None
        
class LinkedList:
    
    def __init__(self):
        self.first = None
        
    def append(self,v):
        curr = self.first
        prev = None
        while curr is not None:
            prev = curr
            curr = curr.next
        if prev is None:
            self.first = Node(v)
        else:
            prev.next = Node(v)
            
    def deleteLast(self):
        if self.first is None: return
        curr = self.first
        prev = None
        while curr.next is not None:
            prev = curr
            curr = curr.next
        if prev is None:
            self.first = None
        else:
            prev.next = None

# P5
def contains_somewhere(v,ls):
    for x in ls:
        if isinstance(x,list):
            if contains_somewhere(v,x):
                return True
        elif v == x:
            return True
    return False

